import Glyph2D.*;
import BallGlyph2D.*;

/**
  * Glyph2DFactory is a factory-class for instantiating Glyph2D-objects.
  * It has an interface to list the available Glyphs and instantiate them.
  */

public class Glyph2DFactory
{
	/**  Gets the number of different Glyphs this factory knows about. */
	public int getNumberofGlyphs()
	{
		return 2;
	}

	/** Gets the name of one glyph type by it's zero-based index. */
	public String getNameofGlyph(int ix)
	{
		if(ix == 0) return new String("Ball2D");
		if(ix == 1) return new String("Triangle2D");
		return null;
	}

	/** Gets an instance of a Glyph2D-object given the index of the glyph. */
	public Glyph2D getGlyphInstance(int ix)
	{
		if(ix == 0) return new BallGlyph2D();
		if(ix == 1) return new BallGlyph2D();
		return null;
	}

	/* Gets the names of the glyphs in a String array. */
	public String[] getGlyphNames()
	{
		String jee[];
		jee = new String[1];
		jee[0] = new String("Ball2D");
		return jee;
	}
}
