/**
  * This is an interface for Glyph's privately implemented
  * components which are used to control glyph properties.
  * This is needed so that the component can get some information
  * about the data without actually using the data objects.
  */

public interface GlyphPropertyControl
{
  /**
    * Sets the minimum value of the data attribute selected for the
    * property this control represents.
    */
  void setDataMin(int min);
  void setDataMin(double min);

  /**
    * Sets the maximum value as above.
    */
  void setDataMax(int max);
  void setDataMax(double max);
}
