import java.awt.*;
import java.lang.*;
import java.awt.event.*;
import java.io.File;
import javax.swing.*;
import javax.swing.border.*;

/**
  * Index is a index for one column of tabular data.
  * @author TL
  */
public class Index{
   private int[] indexArr; //indexvalues = rownumber
   private long[] valueLongArr; //column 
   private double[] valueDoubleArr; //column
   private int[] valueClassArr; //column
   private int rowCount;
   private int attributeType; //0=int, 1= double, 2= class

   //bubble sort
   //-
   private void exchange(int x, int y) {
     int t=indexArr[x];
     indexArr[x]=indexArr[y];
     indexArr[y]=t;
   }
   
   private boolean firstIsSmaller(int firstI, int secondI) {
      boolean isSmaller = true;
      if (attributeType == 0) {
         if (valueLongArr[indexArr[firstI]] >= valueLongArr[indexArr[secondI]])
            isSmaller = false;
      }
      else
      if (attributeType == 1) {
         if (valueDoubleArr[indexArr[firstI]] >= valueDoubleArr[indexArr[secondI]]) 
            isSmaller = false;
      }
      else
      if (attributeType == 2) {
         if (valueClassArr[indexArr[firstI]] >= valueClassArr[indexArr[secondI]])    
            isSmaller = false;       
      } 

      return isSmaller;
   }

   void sort(){
      for (int i = 0; i < rowCount; ++i)
         for (int j = i; j < rowCount; ++j) 
            if (i!=j)
               if(!firstIsSmaller(i,j))
                  exchange(i,j);
   }
  
  /** Constructor creates index on given array (column).
    * @param lognArr - Array on which the index will be made.
    * @param rows - The number of rows in array.
    */
   public Index(long[] longArr, int rows){
      rowCount = rows;
      attributeType = 0;
      valueLongArr = longArr; 
      indexArr = new int[rowCount];
      for (int i = 0;i<rowCount; ++i)
         indexArr[i] = i; //setting the rownumbers to array
      //sorting the column by using bubble sort
      sort();
   }
  /** Constructor creates index on given array (column).
    * @param lognArr - Array on which the index will be made.
    * @param rows - The number of rows in array.
    */
   public Index(double[] doubleArr, int rows) {
      rowCount = rows;
      attributeType = 1;
      valueDoubleArr = doubleArr;
      indexArr = new int[rowCount];
      for (int i = 0;i<rowCount; ++i)
         indexArr[i] = i; //setting the rownumbers to array
      //sorting the column by using bubble sort
      sort();        
   }
  /** Constructor creates index on given array (column).
    * @param lognArr - Array on which the index will be made.
    * @param rows - The number of rows in array.
    */
   public Index(int[] classArr, int rows) {
      rowCount = rows;
      attributeType = 0;
      valueClassArr = classArr;
      indexArr = new int[rowCount];
      for (int i = 0;i<rowCount; ++i)
         indexArr[i] = i; //setting the rownumbers to array
      //sorting the column by using bubble sort
      sort();         
   }
  /** Method finds the first row which is same or bigger than given value. 
    * @return The number of the first row in indexarray, which has same or bigger value. -1 if not found.
    * @param value - The tested value.
    */
   public int findFirst(long value) {
      int returnValue = -1;
      int down = -1;
      int up =  rowCount -1;
      int pivot = 0;
      while (up - down > 1) {
         pivot = (up + down) / 2;
         if (valueLongArr[indexArr[pivot]] >= value)
            up = pivot;
         else
            down = pivot;
      }
      if (valueLongArr[indexArr[up]] >= value)
         returnValue = up;
      return returnValue;
   }
  /** Method finds the first row which is same or bigger than given value.
    * @return The number of the first row in indexarray, which has same or bigger value. -1 if not found.
    * @param value - The tested value.
    */
   public int findFirst(double value) {
      int returnValue = -1;
      int down = -1;
      int up =  rowCount -1;
      int pivot = 0;
      while (up - down > 1) {
         pivot = (up + down) / 2;
         if (valueDoubleArr[indexArr[pivot]] >= value)
            up = pivot;
         else
            down = pivot;
      }
      if (valueDoubleArr[indexArr[up]] >= value)
         returnValue = up;
      return returnValue;    
   };
  /** Method finds the first row which is same or bigger than given value.
    * @return The number of the first row in indexarray, which has same or bigger value. -1 if not found.
    * @param value - The tested value.
    */
    public int findFirst(int value) {
      int returnValue = -1;
      int down = -1;
      int up =  rowCount -1;
      int pivot = 0;
      while (up - down > 1) {
         pivot = (up + down) / 2;
         if (valueClassArr[indexArr[pivot]] >= value)
            up = pivot;
         else
            down = pivot;
      }
      if (valueClassArr[indexArr[up]] >= value)
         returnValue = up;
      return returnValue;
   };   
  /** Method returns the number of row in valuearray. The number of row in indexarray is given.
    * @return The number of row in valuearray.
    * @param rowNo - The number of row in indexarray.
    */
   public int getValue(int rowNo) {
      int returnValue = -1;
      if  ((rowNo >= 0) && (rowNo < rowCount))
         returnValue = indexArr[rowNo]; 
      return returnValue;
   };
}
